/*###########################################################################
#                                                                           #
#          	WIW[ SPK-FM-301 䃂W[(AR1000)            #
#                                                                           #
#                                   C^[tF[XɃn[hEGATWIgp #
###########################################################################*/
#define __AR1000_C__
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "util/delay.h"
#include "ar1000.h"

static uint8_t fmVolume = 0;				/* {[l( 0 ` 22 )		*/

/* R0 `@R17 WX^l					*/
static prog_uint16_t regInitialValues[] = {
	0xfffe ,0x5b15 ,0xf4b9 ,0x8012 ,0x0400 ,0x28aa ,0x4400 ,0x1ee7 ,0x7141 ,
	0x007d ,0x82ce ,0x4f55 ,0x970c ,0xb845 ,0xfc2d ,0x8097 ,0x04a1 ,0xdf6a ,
};

/* {[lWX^lɕϊe[u	*/
static prog_uint8_t tbl[] = {
	0x0f ,0xcf ,0xdf ,0xef ,0xff ,0xee ,0xfe ,0xed ,0xfd ,0xfb ,0xfa ,
	0xf9 ,0xf7 ,0xe6 ,0xf6 ,0xe5 ,0xf5 ,0xe3 ,0xf3 ,0xf2 ,0xf1 ,0xf0
};

/* [J֐vg^Cv錾	*/
static uint8_t fmReadLowSideLoInjection( uint16_t *rssi );
static uint8_t fmReadHighSideLoInjection( uint16_t *rssi );
static uint8_t fmWaitSTC( uint16_t *status );

static uint8_t twiSendStartCondition( void );
static void twiSendEndCondition( void );
static uint8_t twiSendAddress( uint8_t adr );
static uint8_t twiSendByte( uint8_t data );
static uint8_t twiReceiveByte( uint8_t *data ,uint8_t ack );

/*****************************************************************************
*								
* Fvoid
* ߒlFuint8_t 0:OK !0:NG
*
* ֐sAWX^͏lɖ߂
*   W[ׂɁAVXeN̑iKŌĂяo
*****************************************************************************/
uint8_t fmReset( void )
{
	uint8_t i;
	uint8_t ret;
	uint16_t data;

	/* TWI ݒ								*/
	TWCR = 0x00;
	TWBR = (uint8_t)( ( ( F_CPU / TWI_CLOCK ) / 2L ) - 8L );
	TWSR = 0;
	TWCR = _BV(TWEN);	

	/* R0 ` R17 l݁xt@C	*/
	for ( i = 0 ;i < 18 ;i++ ) {
		ret = fmRegWrite( i ,pgm_read_word( &regInitialValues[i] ) );
		if ( ret != 0 ) {
			return ( 1 );
		}

		ret = fmRegRead( i ,&data );
		if ( ret != 0 ) {
			return ( 2 );
		}

		if ( data != pgm_read_word( &regInitialValues[i] ) ) {
			return ( 3 );
		}
	}

	fmVolume = 0;
	return ( 0 );
}

/*****************************************************************************
*								W[L
* Fvoid
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
uint8_t fmEnable( void )
{
	uint16_t status;

	/* {[ݒ				*/
	if ( fmSetVolume( 22 ) != 0 ) {
		return ( 1 );
	}

	/* R0_ENABLE Zbg			*/
	if ( fmRegUpdate( AR_R0 ,AR_R0_ENABLE ,AR_R0_ENABLE ) != 0 ) {
		return ( 2 );
	}

	/* STCtO܂ő҂		*/
	if ( fmWaitSTC( &status ) != 0 ) {
		return ( 3 );
	}

	return ( 0 );
}

/*****************************************************************************
*								{[ݒ
* Fuint8_t vol {[l@0:~[g
*                                 1 ` 22F{[l
* ߒlFuint8_t     0:OK !0:NG
*****************************************************************************/
uint8_t fmSetVolume( uint8_t vol )
{
	if ( vol > 22 ) {
		vol = 22;
	}

	if ( vol == 0 ) {							/* ~[g					*/
		if ( fmRegUpdate( AR_R1 ,AR_R1_HMUTE ,0xffff ) != 0 ) {
			return ( 1 );
		}
	} else {									/* {[ݒ			*/
		uint16_t data = (uint16_t)pgm_read_byte( &tbl[ vol - 1 ] );

		if ( fmRegUpdate( AR_R3 ,AR_R3_VOLUMN ,( data & 0x000f ) << 7 ) != 0 ) {
			return ( 2 );
		}

		if ( fmRegUpdate( AR_R14 ,AR_R14_VOLUME2 ,( data & 0x00f0 ) << 8 ) != 0 ) {
			return ( 3 );
		}

		if ( fmRegUpdate( AR_R1 ,AR_R1_HMUTE ,0x0000 ) != 0 ) {
			return ( 4 );
		}
	}

	fmVolume = vol;
	return ( 0 );
}

/*****************************************************************************
*								{[擾
* Fvoid
* ߒlFuint8_t  {[l ( 0 ` 21 )
*****************************************************************************/
uint8_t fmGetVolume( void )
{
	return ( fmVolume );
}

/****************************************************************************
*								݂RSSIl擾
* Fvoid
* ߒlFuint16_t  RSSIl( 0 ` 2047 )
* 25`35ʂʏM̒lƂȂĂ
****************************************************************************/
uint16_t fmGetRssi( void )
{
	uint16_t rssi = 0;
	uint16_t if_cnt = 0;
	uint16_t val;

	if ( fmRegRead( AR_RSSI ,&val ) != 0 ) {
		return ( 0 );
	}

	rssi = ( ( val & AE_RSSI_RSSI ) >> 9 );
	if_cnt = ( val & AE_RSSI_IF_CNT );

	/* IF_CNT ̒lKl̏ꍇRSSIL		*/
	if ( ( if_cnt >= 233 ) && ( if_cnt <= 277 ) ) {
		return ( rssi );
	}

	return ( 0 );
}

/*****************************************************************************
*								gV[NJn
* Fuint16_t freq  X^[gg ( 0.1MHz=1 / 83.1MHz=831 / 76.1MHz=761 )
*       uint8_t seekup V[N ( 0:seek down / 1:seek up )
*		uint8_t seekth V[N臒l( 0 ` 127 )
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
uint8_t fmStartSeek( uint16_t freq ,uint8_t seekup ,uint8_t seekth )
{
	uint16_t data;
	
	/* Set hmute Bit 							*/
	if ( fmRegUpdate( AR_R1 ,AR_R1_HMUTE ,0xffff ) != 0 ) {
		return ( 1 );
	}

	/* Clear TUNE Bit							*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_TUNE ,0x0000 ) != 0 ) {
		return ( 2 );
	}

	/* Set CHAN Bits							*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_CHAN ,freq - 690 ) != 0 ) {
		return ( 3 );
	}

	/* Clear SEEK Bit							*/
	if ( fmRegUpdate( AR_R3 ,AR_R3_SEEK ,0x0000 ) != 0 ) {
		return ( 4 );
	}

	/* Set SEEKUP/SPACE/BAND/SEEKTH Bits */
	if ( seekup == 0 ) {
		data = ( AR_R3_SPACE | VAL_BAND ) | ( seekth & 0x7f );
	} else {
		data = ( AR_R3_SPACE | VAL_BAND | AR_R3_SEEKUP ) | ( seekth & 0x7f );
	}

	if ( fmRegUpdate( AR_R3 ,AR_R3_SPACE | AR_R3_BAND | AR_R3_SEEKUP | AR_R3_SEEKTH ,data ) != 0 ) {
		return ( 5 );
	}

	/* Enable SEEK Bit */
	if ( fmRegUpdate( AR_R3 ,AR_R3_SEEK ,0xffff ) != 0 ) {
		return ( 6 );
	}

	return ( 0 );
}

/*****************************************************************************
*						gV[NImF
* Fuint16_t *freq   ݃V[N̎g
* ߒlFuint8_t          0:V[N  1:V[N 2:V[Ns  3`:̑G[
*****************************************************************************/
uint8_t fmCheckSeek( uint16_t *freq )
{
	uint16_t data = 0;
	(*freq) = 0;

	/* Xe[^XWX^mF	*/
	if ( fmRegRead( AR_STATUS ,&data ) != 0 ) {
		return ( 3 );
	}

	(*freq) = ( ( ( data & AR_STATUS_READCHAN ) >> 7 ) + 690 );

	if ( ( data & AR_STATUS_STC ) == 0 ) {	/* STCtOĂȂꍇ̓V[N */
		return ( 0 );
	}

	if ( ( data & AR_STATUS_SF ) != 0 ) {	/* SFtOĂꍇ̓V[NG[ */
		return ( 2 );
	}

	/* V[NgI	*/
	if ( fmTune( *freq ) != 0 ) {
		return ( 4 );
	}

	return ( 1 );
}

/*****************************************************************************
*								w̎gɍ킹
* Fuint16_t freq g ( 0.1MHz=1 / 83.1MHz=831 / 76.1MHz=761 )
* ߒlFuint8_t     0:OK !0:NG
*****************************************************************************/
uint8_t fmTune( uint16_t freq )
{
	uint16_t rssi1 ,rssi2 ,status;

	/* Set hmute Bit 							*/
	if ( fmRegUpdate( AR_R1 ,AR_R1_HMUTE ,AR_R1_HMUTE ) != 0 ) {
		return ( 1 );
	}
	
	/* Clear TUNE Bit							*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_TUNE ,0x0000 ) != 0 ) {
		return ( 2 );
	}

	/* Clear SEEK Bit							*/
	if ( fmRegUpdate( AR_R3 ,AR_R3_SEEK ,0x0000 ) != 0 ) {
		return ( 3 );
	}
	
	/* Set BAND / SPACE Bit						*/
	if ( fmRegUpdate( AR_R3 ,AR_R3_SPACE | AR_R3_BAND ,AR_R3_SPACE | VAL_BAND ) != 0 ) {
		return ( 4 );
	}

	/* Set CHAN Bits							*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_CHAN ,freq - 690 ) != 0 ) {
		return ( 5 );
	}

	/* Read Low-side LO Injection 				*/
	if ( fmReadLowSideLoInjection( &rssi1 ) != 0 ) {
		return ( 5 );
	}
	
	/* Read High-side LO Injection				*/
	if ( fmReadHighSideLoInjection( &rssi2 ) != 0 ) {
		return ( 6 );
	}
	
	/* Compare Hi/Lo Side Signal Strength		*/
	if ( rssi1 > rssi1 ) {						/* clear D15 , set D0 / D2 */
		if ( fmRegUpdate( AR_R11 ,AR_R11_HILO_SIDE | AR_R11_HILOCTRL_B2 | AR_R11_HILOCTRL_B1 ,AR_R11_HILOCTRL_B2 | AR_R11_HILOCTRL_B1 ) != 0 ) {
			return ( 7 );
		}

	} else {									/* set D15 , clear D0 / D2 */
		if ( fmRegUpdate( AR_R11 ,AR_R11_HILO_SIDE | AR_R11_HILOCTRL_B2 | AR_R11_HILOCTRL_B1 ,AR_R11_HILO_SIDE ) !=0 ) {
			return ( 8 );
		}
	}

	/* Enable TUNE BitClear TUNE Bit			*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_TUNE ,AR_R2_TUNE ) != 0 ) {
		return ( 10 );
	}

	/* Wait STC flag (Seek/Tune Complete, in gStatush register)	*/
	if ( fmWaitSTC( &status ) != 0 ) {
		return ( 11 );
	}

	/* Clear hmute Bit							*/
	if ( fmRegUpdate( AR_R1 ,AR_R1_HMUTE ,0x0000 ) != 0 ) {
		return ( 12 );
	}

	return ( 0 );
}

/*****************************************************************************
*						Read Low-side LO Injection
* Fuint16_t *rssi 擾f[^Ԃ
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
static uint8_t fmReadLowSideLoInjection( uint16_t *rssi )
{
	uint16_t status;

	(*rssi) = 0;

	/* Set R11 ( clear D15, clear D0/D2 )		*/
	if ( fmRegUpdate( AR_R11 ,AR_R11_HILO_SIDE | AR_R11_HILOCTRL_B2 | AR_R11_HILOCTRL_B1 ,0x0000 ) != 0 ) {
		return ( 1 );
	}

	/* Enable TUNE Bit												*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_TUNE ,0xffff ) != 0 ) {
		return ( 2 );
	}

	/* Wait STC flag (Seek/Tune Complete, in gStatush register)	*/
	if ( fmWaitSTC( &status ) != 0 ) {
		return ( 3 );
	}

	/* Get RSSI (RSSI1)												*/
	(*rssi) = fmGetRssi();

	/* Clear TUNE Bit												*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_TUNE ,0x0000 ) != 0 ) {
		return ( 4 );
	}

	return ( 0 );
}

/*****************************************************************************
*						Read High-side LO Injection
* Fuint16_t *rssi 擾f[^Ԃ
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
static uint8_t fmReadHighSideLoInjection( uint16_t *rssi )
{
	uint16_t status;

	(*rssi) = 0;

	/* Set R11( set D15, set D0/D2 )								*/
	if ( fmRegUpdate( AR_R11 ,AR_R11_HILO_SIDE | AR_R11_HILOCTRL_B2 | AR_R11_HILOCTRL_B1 ,0xffff ) != 0 ) {
		return ( 1 );
	}

	/* Enable TUNE Bit												*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_TUNE ,0xffff ) != 0 ) {
		return ( 2 );
	}

	/* Wait STC flag (Seek/Tune Complete, in gStatush register)	*/
	if ( fmWaitSTC( &status ) != 0 ) {
		return ( 3 );
	}

	/* Get RSSI (RSSI1)												*/
	(*rssi) = fmGetRssi();

	/* Clear TUNE Bit												*/
	if ( fmRegUpdate( AR_R2 ,AR_R2_TUNE ,0x0000 ) != 0 ) {
		return ( 4 );
	}

	return ( 0 );
}

/*****************************************************************************
*							STCtO܂ő҂	
* Fuint16_t *status Xe[^XWX^̒lԂ
* ߒlFuint8_t  0:OK !0:NG
*****************************************************************************/
static uint8_t fmWaitSTC( uint16_t *status )
{
	uint16_t data = 0;
	(*status) = 0;

	do {
		_delay_ms( 0.5 );
		if ( fmRegRead( AR_STATUS ,&data ) != 0 ) {
			return ( 1 );
		}
	} while ( ( data & AR_STATUS_STC ) == 0 );

	(*status) = data;
	return ( 0 );
}

/*****************************************************************************
*							w背WX^̈ꕔ
* Fuint8_t reg WX^ԍ
*       uint16_t mask srbg1w肷
*		uint16_t data ރf[^
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
uint8_t fmRegUpdate( uint8_t reg ,uint16_t mask ,uint16_t data )
{
	uint8_t ret;
	uint16_t regData;

	/* WX^Ǎ			*/
	ret = fmRegRead( reg ,&regData );
	if ( ret != 0 ) {
		return ( 1 );
	}

	/* f[^}XN			*/
	regData = ( regData & ~mask ) | ( data & mask );

	/* WX^			*/
	ret = fmRegWrite( reg ,regData );
	if ( ret != 0 ) {
		return ( 2 );
	}

	return ( 0 );
}

/*****************************************************************************
*							AR1000WX^
* Fuint8_t reg    WX^ԍ
*       uint16_t data  ރf[^
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
uint8_t fmRegWrite( uint8_t reg ,uint16_t data )
{
	uint8_t h = (uint8_t)( data >> 8 );
	uint8_t l = (uint8_t)( data & 0x00ff );

	if ( twiSendStartCondition() != 0 ) {		/* X^[gRfBV	*/
		return ( 11 );
	}
	_delay_us( 15 );

	if ( twiSendAddress( 0x20 ) != 0 ) {		/* foCXAhX(Cg)	*/
		twiSendEndCondition();
		return ( 12 );
	}
	_delay_us( 15 );

	if ( twiSendByte( reg ) != 0 ) {			/* WX^ԍ		*/
		twiSendEndCondition();
		return ( 13 );
	}
	_delay_us( 15 );

	if ( twiSendByte( h ) != 0 ) {				/* ʃoCg			*/
		twiSendEndCondition();
		return ( 14 );
	}
	_delay_us( 15 );

	if ( twiSendByte( l ) != 0 ) {				/* ʃoCg			*/
		twiSendEndCondition();
		return ( 15 );
	}
	_delay_us( 15 );

	twiSendEndCondition();
	_delay_us( 15 );

	return ( 0 );
}

/*****************************************************************************
*							AR1000WX^ǂݍ
* Fuint8_t reg    WX^ԍ
*       uint16_t *data f[^i[ϐւ̃|C^
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
uint8_t fmRegRead( uint8_t reg ,uint16_t *data )
{
	uint8_t h = 0;
	uint8_t l = 0;

	if ( twiSendStartCondition() != 0 ) {		/* X^[gRfBV	*/
		return ( 21 );
	}
	_delay_us( 15 );

	if ( twiSendAddress( 0x20 ) != 0 ) {		/* foCXAhX(Cg)	*/
		twiSendEndCondition();
		return ( 22 );
	}
	_delay_us( 15 );

	if ( twiSendByte( reg ) != 0 ) {			/* WX^ԍ		*/
		twiSendEndCondition();
		return ( 23 );
	}
	_delay_us( 15 );

	if ( twiSendStartCondition() != 1 ) {		/* X^[gRfBV	*/
		twiSendEndCondition();
		return ( 24 );
	}
	_delay_us( 15 );

	if ( twiSendAddress( 0x21 ) != 0 ) {		/* foCXAhX([h)	*/
		twiSendEndCondition();
		return ( 25 );
	}
	_delay_us( 15 );

	if ( twiReceiveByte( &h ,0 ) != 0 ) {		/* ʃoCgǍ			*/
		twiSendEndCondition();
		return ( 26 );
	}
	_delay_us( 15 );

	if ( twiReceiveByte( &l ,1 ) != 0 ) {		/* ʃoCgǍ			*/
		twiSendEndCondition();
		return ( 27 );
	}
	_delay_us( 15 );

	twiSendEndCondition();
	_delay_us( 15 );

	(*data) = ( (uint16_t)h << 8 ) | (uint16_t)l;

	return ( 0 );
}

/*****************************************************************************
*								TWIJnM
* Fvoid
* ߒlFuint8_t 0:JnM
*               1:đJnM
*              99:NG
*****************************************************************************/
static uint8_t twiSendStartCondition( void )
{
	/* JnM						*/
	TWCR = _BV(TWEN) | _BV(TWINT) | _BV(TWSTA);

	/* M(TWINT)܂ő҂	*/
	while ( !( TWCR & _BV(TWINT) ) );

	/* TWIXe[^X(Bit7:3)		*/
	uint8_t sts = TWSR;
	sts &= 0xf8;
	if ( sts == 0x08 ) {						/* JnM 	*/
		return ( 0 );
	} else if ( sts == 0x10 ) {					/* đJnM */
		return ( 1 );
	}

	return ( 99 );
}

/*****************************************************************************
*								TWIIM
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void twiSendEndCondition( void )
{
	TWCR = _BV(TWEN) | _BV(TWINT) | _BV(TWSTO);
}

/*****************************************************************************
*						TWI AhXM
* Fuint8_t adr AhX(7bit) + R/W(1bit 0:Write 1:Read)
* ߒlFuint8_t     0:OK !0:NG
*****************************************************************************/
static uint8_t twiSendAddress( uint8_t adr )
{
	/* M								*/
	TWDR = adr;
	TWCR = _BV(TWINT) | _BV(TWEN);

	/* M(TWINT)܂ő҂	*/
	while ( !( TWCR & _BV(TWINT) ) );

	/* TWIXe[^X(Bit7:3)		*/
	uint8_t sts = TWSR;
	sts &= 0xf8;
	if ( sts == 0x20 ) {					/* SLA+WM NACKM		*/
		return ( 1 );
	} else if ( sts == 0x48 ) {				/* SLA+RM NACKM		*/
		return ( 2 );
	} else if ( sts == 0x18 ) {				/* SLA+WM ACKM		*/
		if ( ( adr & 0x01 ) == 0 ) {
			return ( 0 );
		}
		return ( 3 );
	} else if ( sts == 0x40 ) {				/* SLA+RM ACKM		*/
		if ( ( adr & 0x01 ) != 0 ) {
			return ( 0 );
		}
		return ( 4 );
	}

	return ( 99 );
}

/*****************************************************************************
*								TWI 1oCgM
* Fuint8_t data Mf[^
* ߒlFuint8_t      0:ACK 1:NACK 99:NG
*****************************************************************************/
static uint8_t twiSendByte( uint8_t data )
{
	/* M								*/
	TWDR = data;
	TWCR = _BV(TWINT) | _BV(TWEN);

	/* M(TWINT)܂ő҂	*/
	while ( !( TWCR & _BV(TWINT) ) );

	/* TWIXe[^X(Bit7:3)		*/
	uint8_t sts = TWSR;
	sts &= 0xf8;
	if ( sts == 0x28 ) {					/* ް ޲đM ACKM 		*/
		return ( 0 );
	} else if ( sts == 0x30 ) {				/* ް ޲đM NACKM		*/
		return ( 1 );
	}

	return ( 99 );
}

/*****************************************************************************
*							TWI 1oCgM
* Fuint8_t *data Mf[^i[̈ւ̃|C^
*       uint8_t ack   0:ACKM !0:NACKM
* ߒlFuint8_t       0:OK      !0:NG
*****************************************************************************/
static uint8_t twiReceiveByte( uint8_t *data ,uint8_t ack )
{
	/* MFACK/NACKɉTWEArbgZbg */
	if ( ack == 0 ) {
		TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWEA);
	} else {
		TWCR = _BV(TWINT) | _BV(TWEN);
	}

	/* M(TWINT)܂ő҂	*/
	while ( !( TWCR & _BV(TWINT) ) );

	/* Mf[^擾					*/
	(*data) = TWDR;

	/* TWIXe[^X(Bit7:3)		*/
	uint8_t sts = TWSR;
	sts &= 0xf8;
	if ( sts == 0x50 ) {					/* ް ޲ĎM ACKM		*/
		if ( ack == 0 ) {
			return ( 0 );
		}
		return ( 1 );
	} else if ( sts == 0x58 ) {				/* ް ޲đM NACKM		*/
		if ( ack != 0 ) {
			return ( 0 );
		}
		return ( 2 );
	}

	return ( 99 );
}
