/*###########################################################################
#                                                                           #
#  					      	CRCvZW[								#
#                                                                           #
###########################################################################*/
#define __CRC_C__

#include <avr/io.h>
#include <avr/eeprom.h>
#include <util/crc16.h>
#include "crc.h"

/*****************************************************************************
*						EEPROM̈CRC16vZ
* Fuint16_t addr 擪AhX
*		uint16_t len  f[^
* ߒlFuint16_t      CRC16l
*****************************************************************************/
uint16_t crc16_CalcEEPROM( uint16_t addr ,uint16_t len )
{
	uint8_t *p = (uint8_t *)addr;
	uint16_t crc = crc16_start();
	while ( len-- ) {
		eeprom_busy_wait();
		crc = crc16_update( crc ,eeprom_read_byte( p++ ) );
	}
	crc = crc16_end( crc );
	return ( crc );
}

/*****************************************************************************
*							RAM̈CRC16vZ
* Fvoid     *addr 擪AhX
*		uint16_t len   f[^
* ߒlFuint16_t       CRC16l
*****************************************************************************/
uint16_t crc16_CalcRAM( void *addr ,uint16_t len )
{
	uint8_t *p = (uint8_t *)addr;
	uint16_t crc = crc16_start();
	while ( len-- ) {
		crc = crc16_update( crc ,*p++ );
	}
	crc = crc16_end( crc );
	return ( crc );
}

/*****************************************************************************
*						CRC̏l擾
* Fvoid
* ߒlFuint16_t l ( 0xffffŒ )
*****************************************************************************/
uint16_t crc16_start( void )
{
	return ( 0xffff );
}

/*****************************************************************************
*							CRClXV
* Fuint16_t crc  ݂CRCl
*		uint8_t  data f[^
* ߒlFuint16_t vZl
*****************************************************************************/
uint16_t crc16_update( uint16_t crc ,uint8_t data )
{
	return ( _crc16_update( crc ,data ) );
}

/*****************************************************************************
*							CRCl̍XVI
* Fuint16_t crc  ݂CRCl
* ߒlFuint16_t vZl
*****************************************************************************/
uint16_t crc16_end( uint16_t crc )
{
	return ( crc ^ 0xffff );
}
