/*###########################################################################
#                                                                           #
#                              CW[                             #
#                                                                           #
###########################################################################*/
#define __MAIN_C__
#include "project.h"

/* [J֐vg^Cv錾		*/
static void hardwareInit( void );

/*****************************************************************************
*						timer1(16bit)ɂ10msec̊荞
*								VXe^C}[
*****************************************************************************/
ISR( SIG_OUTPUT_COMPARE1A )
{
	static uint8_t ms1000Count = 0;				/* 1000msecJE^			*/
	static uint8_t ms100Count = 0;				/* 100msecJE^			*/
	static uint8_t keyPollingPermission = 0;	/* L[|[OtO	*/

	/* ̊荞݃^C~Oݒ	*/
	OCR1A += OCR1B;

	/* L[|[O				*/
	if ( keyPollingPermission != 0 ) {
		keysWatchKey();

	} else if ( POWER_BUTTON() ) {	/* d{^ĂH							*/
		keyPollingPermission = 1;	/* L[|[O									*/
		PCICR = _BV( PCIE0 );		/* PCINT4(PB4)/PCINT5(PB5)荞݂(JOG_Cp)	*/
		PCMSK0 = 0x30;
		keysInit();
	}

	/* drdADϊ^C~O		*/
	if ( sys.ADcountDownTimer ) {
		sys.ADcountDownTimer--;
	} else {
		sys.ADcountDownTimer = AD_INTERVAL_TIME;
		ADCSRA |= _BV(ADSC);				/* ADϊJn									*/
	}

	/* eJEg_E^C}[(10msecɃJEg_E)	*/
	if ( sys.countDownTimer1 ) {			/* XyAiERSSI\^C~Op				*/	
		sys.countDownTimer1--;
	}

	if ( sys.countDownTimer2 ) {			/* eLXgXN[^C~Op				*/
		sys.countDownTimer2--;
	}

	if ( sys.countDownTimer3 ) {			/* ʃtF[h^C~Op					*/
		sys.countDownTimer3--;
	}

	if ( sys.countDownTimer4 ) {			/* ʃtF[h^C~Op					*/
		sys.countDownTimer4--;
	}

	/* ĐԃJEgAbv		*/
	if ( sys.dspTransFlag ) {				/* DSP]?									*/
		sys.playTime++;
		if ( sys.playTime % 10L ) {
			sys.tickPlayTime = 1;			/* playTimeXVtOON							*/
		}
	}

	/* ʃtF[hAEg^C~OtO	*/
	sys.tickScreenFade = 1;

	/* 100msec̏				*/
	if ( ++ms100Count >= 10 ) {
		ms100Count = 0;

		/* 쑗ԃ^C}[		*/
		if ( sys.notProccesCountDownTimer ) {
			sys.notProccesCountDownTimer--;
		}

		/* OFFJE^			*/
		if ( ( sys.screenOffCountDownTimer != 0xffff ) && ( sys.screenOffCountDownTimer != 0 ) ) {
			sys.screenOffCountDownTimer--;
		}
	}

	/* 1b̏					*/
	if ( ++ms1000Count >= 100 ) {
		ms1000Count = 0;

		/* Vbg_EJE^	*/
		if ( ( sys.shutdownCountDownTimer != 0xffff ) && ( sys.shutdownCountDownTimer != 0 ) ) {
			sys.shutdownCountDownTimer--;
			sys.tickShutdownCountDownTimer = 1;
		}

		/* VXe				*/
		sys.systemTime++;
	}
}

/*****************************************************************************
*@						A/Dϊ̊荞
*****************************************************************************/
ISR( SIG_ADC )
{
	sys.batteryAD = ADC;
	sys.flag_adTranslationCompletion = 1;
}

/*****************************************************************************
*								ݒ
*@Fvoid
*@ߒlFvoid
*****************************************************************************/
static void hardwareInit( void )
{
	char buf[32];
	uint8_t ret;

	/* EIb`hbNݒ									*/
	wdt_enable( WDTO_4S );

	/* d̓Jbg											*/
	ACSR = _BV(ACD);							/* AiORp[^d͒~	*/

	/* 	PortA +--------7: ZHI    : AD7											*/
	/*        |+-------6: ZHI    : AD6											*/
	/*        ||+------5: ZHI    : AD5											*/
	/*        |||+-----4: ZHI    : AD4											*/
	/*        ||||+----3: ZHI    : AD3											*/
	/*        |||||+---2: ZHI    : AD2	 										*/
	/*        ||||||+--1: ZHI    : AD1											*/
	/*        |||||||+-0: ZHI    : AD0											*/
	DDRA  = 0b00000000;
	PORTA = 0b00000000;

	/* 	PortB +--------7:Out(L) : LCD BACK-LIGHT								*/
	/*        |+-------6:Pullup	: gp										*/
	/*        ||+------5:Pullup : _C										*/
	/*        |||+-----4:Pullup : _C										*/
	/*        ||||+----3:ZHI    : FLASH SO										*/
	/*        |||||+---2:Out(H) : FLASH SI										*/
	/*        ||||||+--1:Out(L) : FLASH SCK 									*/
	/*        |||||||+-0:Out(H) : FLASH #CS										*/
	DDRB  = 0b10000111;
	PORTB = 0b01110101;

	/* 	PortC +--------7: ZHI    : AD15											*/
	/*        |+-------6: ZHI    : AD14											*/
	/*        ||+------5: ZHI    : AD13											*/
	/*        |||+-----4: ZHI    : AD12											*/
	/*        ||||+----3: ZHI    : AD11											*/
	/*        |||||+---2: ZHI    : AD10	 										*/
	/*        ||||||+--1: ZHI    : AD9											*/
	/*        |||||||+-0: ZHI    : AD8											*/
	DDRC  = 0b00000000;
	PORTC = 0b00000000;

	/* 	PortD +--------7: Out(H) : SD CARD #POW									*/
	/*        |+-------6: Pullup : SD CARD #INS									*/
	/*        ||+------5: Out(L) : SD CARD SCK									*/
	/*        |||+-----4: Out(H) : SD CARD #CS									*/
	/*        ||||+----3: Out(H) : SD CARD SI									*/
	/*        |||||+---2: ZHI    : SD CARD SO									*/
	/*        ||||||+--1: Pullup : FMradio(TWI)									*/
	/*        |||||||+-0: Pullup : FMradio(TWI)									*/
	DDRD  = 0b10111000;
	PORTD = 0b11011011;

	/* 	PortE +--------7: Out(L) : FLASH #RESET									*/
	/*        |+-------6: Out(L) : VS #RESET									*/
	/*        ||+------5: ZHI    : VS DREQ										*/
	/*        |||+-----4: Out(H) : VS #XDCS										*/
	/*        ||||+----3: Out(H) : VS #XCS										*/
	/*        |||||+---2: Out(L) : VS SCLK										*/
	/*        ||||||+--1: Out(H) : VS SI / ISP(MISO)							*/
	/*        |||||||+-0: ZHI    : VS SO / ISP(MOSI)							*/
	DDRE  = 0b11011110;
	PORTE = 0b00011010;

	/* 	PortF +--------7: ZHI    : drd|[g							*/
	/*        |+-------6: Pullup : [dj^									*/
	/*        ||+------5: Pullup : dSWj^									*/
	/*        |||+-----4: Out(L) : dz[h(L: H:z[h)				*/
	/*        ||||+----3: Pullup : O											*/
	/*        |||||+---2: Pullup : O											*/
	/*        ||||||+--1: Pullup : O											*/
	/*        |||||||+-0: Pullup : O											*/
	DDRF  = 0b00010000;
	PORTF = 0b01101111;

	/* 	PortG +--------7: Pullup : ----											*/
	/*        |+-------6: Pullup : ----											*/
	/*        ||+------5: Pullup : ----											*/
	/*        |||+-----4: Pullup : gp										*/
	/*        ||||+----3: Out(L) : LCD #RESET									*/
	/*        |||||+---2: ZHI    : ALE											*/
	/*        ||||||+--1: ZHI    : #WR											*/
	/*        |||||||+-0: ZHI    : #RD											*/
	DDRG  = 0b00001000;
	PORTG = 0b11110000;

	/* C^[tF[X		*/
//	XMCRA = 0b11001111;									/* 2WAIT				*/
//	XMCRA = 0b11000101;									/* 1WAIT				*/
	XMCRA = 0b11000000;									/* 0WAIT				*/
	XMCRB = 0;

	/* A/Dϊݒ						*/
#if ( REF_VOLTAGE == 110 )
	ADMUX = _BV(REFS1) | AD_CH;							/* `lI		 	*/
														/* d : 1.10V	*/
														/* Erbg			*/
#elif ( REF_VOLTAGE == 256 )
	ADMUX = _BV(REFS1) | _BV(REFS0) | AD_CH;			/* `lI		 	*/
														/* d : 2.56V	*/
														/* Erbg			*/
#else
	#error Do not forget to set REF_VOLTAGE

#endif

	DIDR0 = _BV(AD_CH);								/* A/Dϊ|[gfW^͋֎~*/

	ADCSRA  = _BV(ADPS2) | _BV(ADPS1) | _BV(ADPS0);	/* A/DϊNbN F_CPU128	*/

	ADCSRA |= _BV(ADEN) | _BV(ADIE) | _BV(ADSC);	/* A/DϊL					*/
													/* A/DϊI݋		*/
													/* A/DϊJn(̈)		*/

	/*	^C}[1(16bit)ݒ VXe^C}[(10msec)	*/
	OCR1B = (uint16_t)( ( F_CPU / 256L ) / 100L );
	TCCR1B = 0x04;									/* F_CPU / 256					*/
	OCR1A = OCR1B;
	TIMSK1 |= _BV(OCIE1A);

	/* LCD						*/
	lcdInit();

	/* VS1053B 					*/
	vsInit();

	/* VAtbV			*/
	ret = flashInit();
	if ( ret ) {
		sprintf_P( buf ,PSTR("FLASH MEMORY ERROR %d") ,ret );
		lcdPuts( 0 ,0 ,buf ,RGB( 255 ,0 ,0 ) ,RGB( 0, 0, 0 ) );
		wdt_reset(); while ( 1 );
	}

	/* FMWIW[			*/
	ret = fmReset();
	if ( ret ) {
		sprintf_P( buf ,PSTR("FM RADIO ERROR %d") ,ret );
		lcdPuts( 0 ,0 ,buf ,RGB( 255 ,0 ,0 ) ,RGB( 0, 0, 0 ) );
		wdt_reset(); while ( 1 );
	}

	/* R\[					*/
	consoleInit();
}

/*****************************************************************************
*									C
*****************************************************************************/
int main( void )
{
	/* VXe					*/
	hardwareInit();

	/* dON						*/
	powerON();

	/* VXeϐ				*/
	sys.playInfo.titleBufferSize = LFN_LENGTH;
	sys.playInfo.authorBufferSize = LFN_LENGTH;
	sys.playInfo.author = &sys.textBuffer[0];
	sys.playInfo.title = &sys.textBuffer[ LFN_LENGTH + 8 ];
	sys.shutdownCountDownTimer = eep.shutdownTimer;
	sys.screenBrightness = eep.screenBrightness;
	sys.flag_sdInsert = 0xff;
	sys.bgIndex = FL_BG_SYSTEM_INDEX;
	if ( eep.volume > 7 ) eep.volume = 7;			/* N̉ʃ~bg		*/

	/* ݐ						*/
	ADCSRA |= _BV(ADIF);							/* A/DϊσtOZbg	*/
	TCNT1 = 0;
	sei();
	sys.ADcountDownTimer = 0;						/* ŏA/Dϊl擾		*/
	while ( sys.flag_adTranslationCompletion == 0 );

	/*	C						*/
	while ( 1 ) {
		wdt_reset();

		/* v[[EFMWIʎs		*/
		if ( eep.screenIndex == 1 ) {
			menu001();							/* v[[			*/
			eep.screenIndex = 2;

		} else if ( eep.screenIndex == 2 ) {
			menu002();							/* FMWI				*/
			eep.screenIndex = 1;
		}
	}

	return ( 0 );
}
