/*###########################################################################
#                                                                           #
#                 		 @VXe\W[   					#
#                                                                           #
###########################################################################*/
#define __SCREEN021_C__
#include "project.h"

/* \̈						*/
#define MX1 6									/* \̈捶XW		*/
#define MY1 17									/* \̈捶YW		*/

#define INTERVAL 10								/* XVԊu X10msec		*/

/* [J֐vg^Cv錾		*/
static void drawFullScreen( void );
static void drawVersion( uint8_t y );
static void drawBattVoltage( uint8_t y );
static void drawMediaInfo( uint8_t y );
static void drawShutDownHistory( uint8_t y );

/*****************************************************************************
*							VXe\
* Fvoid
* ߒlFuint8_t 0:OK !0:ACh^C}[쓮
*****************************************************************************/
uint8_t menu021( void )
{
	/* \									*/
	drawFullScreen();

	/*	C								*/
	sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
	while ( sys.notProccesCountDownTimer ) {

		/* Tuj[obNOh		*/
		player_backProcess_for_submenu( &drawFullScreen );

		/* 100msec̏						*/
		if ( !sys.countDownTimer2 ) {
			sys.countDownTimer2 = INTERVAL;

			/* SDJ[h\					*/
			drawMediaInfo( MY1 + 20 );

			/* dreʕ\						*/
			drawBattVoltage( MY1 + 10 );
		}

		/* {^						*/
		uint8_t ky = keysInkey();
		if ( ky != KEY_NOTHING ) {

			/* ԃ{^FVbg_E	*/
			if ( ky == ( KEY_RED | KEY_LONGPUSH_START ) ) {
				shutdown( SHUTDOWN_USER );

			/* {^ZF	LZ		*/
			} else if ( ky == KEY_BLACK ) {
				return ( 0 );

			/* ԃ{^ZFLZ		*/
			} else if ( ky == KEY_RED ) {
				return ( 0 );
			}

			/* ^C}[Zbg		*/
			sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
		}
	}
	return ( 1 );
}

/*****************************************************************************
*							ʕ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void drawFullScreen( void )
{
	sys.screenOffCountDownTimer = 0xffff;
	sys.screenBrightness = eep.screenBrightness;

	lcdSetBrightness( 0 );
	sysDraw_cls();
	sysDraw_battery();

	drawVersion( MY1 + 0 );
	drawBattVoltage( MY1 + 10 );
	drawMediaInfo( MY1 + 20 );
	drawShutDownHistory( MY1 + 65 );

	lcdSetBrightness( eep.screenBrightness );
	keysClear();

	sys.countDownTimer2 = INTERVAL;
}

/*****************************************************************************
*								nPMP o[W\
* Fuint8_t y \YW
* ߒlFvoid
*****************************************************************************/
static void drawVersion( uint8_t y )
{
	char buf[24];

	strcpy_P( buf ,PSTR("version") );
	g_putsAscii( MX1 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

	strcpy_P( buf ,PSTR(VERSION) );
	g_putsAscii( MX1 + 90 ,y ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );
}

/*****************************************************************************
*								drd\
* Fuint8_t y \YW
* ߒlFvoid
*****************************************************************************/
static void drawBattVoltage( uint8_t y )
{
	char buf[24];
	uint16_t batt = getBattVoltage();

	strcpy_P( buf ,PSTR("voltage") );
	g_putsAscii( MX1 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

	sprintf_P( buf ,PSTR("%d.%02d") ,batt / 100 ,batt % 100 );
	g_putsAscii( MX1 + 84 ,y ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	strcpy_P( buf ,PSTR("V") );
	g_putsAscii( MX1 + 108 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );
}

/*****************************************************************************
*							fBA\
* Fuint8_t y \YW
* ߒlFvoid
*****************************************************************************/
static void drawMediaInfo( uint8_t y )
{
	char buf[24];
	uint32_t sectorCount = 0L;					/* SZN^				*/
	uint16_t sectorSize = 0;					/* 1ZN^ӂ̃TCY		*/
	uint32_t blockSize = 0L;					/* ubNTCY			*/
	uint32_t totalSize = 0L;					/* fBÃTCY			*/
	uint8_t typ = 0;							/* fBA^Cv			*/

	/* fBA擾				*/
	if ( !SD_INS() ) {
		if ( eep.screenIndex == 1 ) {
			dspDisable();
		} else {
			disk_initialize( 0 );
		}

		disk_ioctl( 0 ,GET_SECTOR_COUNT ,&sectorCount );
		disk_ioctl( 0 ,GET_SECTOR_SIZE ,&sectorSize );		/* 512Œ		*/
		disk_ioctl( 0 ,GET_BLOCK_SIZE ,&blockSize );
		disk_ioctl( 0 ,MMC_GET_TYPE ,&typ );
		totalSize = sectorCount / 2048L;					/* MB			*/

		if ( eep.screenIndex == 1 ) {
			if ( sys.playMode & PLAY_STS_DSP_BIT ) {
				dspEnable();
			}
		} else {
			uint8_t pow = 0;
			disk_ioctl( 0 ,CTRL_POWER ,&pow );
		}
	}

	/* fBA^Cv\			*/
	strcpy_P( buf ,PSTR("media") );
	g_putsAscii( MX1 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

	strcpy_P( buf ,PSTR("     ---" ) );
	if ( typ & 0x01 ) {								/* MMC					*/
		strcpy_P( buf ,PSTR("     MMC") );
	} else if ( typ & 0x02 ) {						/* SDC ver 1.xx			*/
		strcpy_P( buf ,PSTR("SDC ver1") );
	} else if ( typ & 0x04 ) {						/* SDC ver 2.00			*/
		if ( typ & 0x08 ) {							/* Block[hΉ		*/
			strcpy_P( buf ,PSTR("    SDHC" ) );
		} else {									/* Block[hΉ	*/
			strcpy_P( buf ,PSTR("SDC ver2") );
		}
	}
	g_putsAscii( MX1 + 67 ,y ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	/* ZN^\					*/
	y += 8;
	strcpy_P( buf ,PSTR("sectors") );
	g_putsAscii( MX1 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

	if ( sectorCount ) {
		utoa_kanma( sectorCount ,buf ,11 );
	} else {
		strcpy_P( buf ,PSTR("        ---") );
	}
	g_putsAscii( MX1 + 48 ,y ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	/* ZN^TCY\				*/
	y += 8;
	strcpy_P( buf ,PSTR("sector size") );
	g_putsAscii( MX1 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

	if ( sectorSize ) {
		utoa_kanma( sectorSize ,buf ,6 );
	} else {
		strcpy_P( buf ,PSTR("   ---") );
	}
	g_putsAscii( MX1 + 78 ,y ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	/* ubNTCY\			*/
	y += 8;
	strcpy_P( buf ,PSTR("block size") );
	g_putsAscii( MX1 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );
	if ( sectorCount ) {
		utoa_kanma( blockSize ,buf ,9 );
	} else {
		strcpy_P( buf ,PSTR("      ---") );
	}
	g_putsAscii( MX1 + 60 ,y ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	/* fBXNSeʕ\			*/
	y += 8;
	strcpy_P( buf ,PSTR("capacity") );
	g_putsAscii( MX1 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

	if ( totalSize ) {
		utoa_kanma( totalSize ,buf ,7 );
	} else {
		strcpy_P( buf ,PSTR("    ---") );
	}
	g_putsAscii( MX1 + 60 ,y ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	strcpy_P( buf ,PSTR("MB") );
	g_putsAscii( MX1 + 102 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );
}

/*****************************************************************************
*						Vbg_E\
* Fuint8_t y \YW
* ߒlFvoid
*****************************************************************************/
static void drawShutDownHistory( uint8_t y )
{
	char buf[24];
	uint8_t i;
	uint8_t type;
	uint8_t h ,m ,s;

	for ( i = 0 ;i < HIS_SHUTDOWN_COUNT ;i++ ) {
		/* Vbg_EACe擾	*/
		type = eep.his_shutDownType[i];
		h = eep.his_powerOnTime[i] / 3600;
		m = ( eep.his_powerOnTime[i] % 3600 ) / 60;
		s = eep.his_powerOnTime[i] % 60;

		/* No.\						*/
		sprintf_P( buf ,PSTR("%d") ,i + 1 );
		g_putsAscii( MX1 ,y ,buf ,sys.gDrawMode ,RGB(255,255,0) ,RGB(0,0,0) );

		/* Vbg_ER\		*/
		if ( type == SHUTDOWN_USER ) {
			strcpy_P( buf ,PSTR("user") );
		} else if ( type == SHUTDOWN_TIMER ) {
			strcpy_P( buf ,PSTR("timer") );
		} else if ( type == SHUTDOWN_LOWBATT ) {
			strcpy_P( buf ,PSTR("lowbatt") );
		} else if ( type == SHUTDOWN_NOT_PROCESS_TIMER ) {
			strcpy_P( buf ,PSTR("idol") );
		} else {
			strcpy_P( buf ,PSTR("-------") );
		}
		g_putsAscii( MX1 + 12 ,y ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

		/* ғԕ\					*/
		sprintf_P( buf ,PSTR("%2d:%02d:%02d") ,h ,m ,s );
		g_putsAscii( MX1 + 66 ,y ,buf ,sys.gDrawMode ,RGB(0,255,255) ,RGB(0,0,0) );
		y += 8;
	}
}
